# Contributing to this project

👋 Welcome! Thanks for your interest in `elm-music-theory`.

If you have a question about this project, feel free to reach out to me at `@duncan` on the [Elm Slack](https://elmlang.herokuapp.com/).

## No design contributions please (for now)

I am currently working on the design of this project myself and am not accepting unsolicited contributions that add features or change the design of the API. This may change in the future!

But if you are interested, please contribute in the following ways:

## Share your use cases

**Are you working on a project that you are considering using `elm-music-theory` for?** I want to support the features you would need if they seem relevant to the scope of this library. Reach out to me at `@duncan` on the [Elm Slack](https://elmlang.herokuapp.com/) and tell me about it.

## Report issues

**Have you found a problem or behavior that seems wrong?** Open an issue with a [Short, Self Contained, Correct Example](http://sscce.org/) of code that produces the problem.

Sometimes it can be hard to understand a bug report out of context, so when reporting a bug, please include the following:
- What you were trying to do
- What you expected to happen and why

After we discuss the bug and agree on the correct behavior and possible API changes, I am open to PRs that would address the issues. But it is always a great move to start a conversation first.

## Share your theory knowledge

Although I have done some independent study of piano, jazz theory, and basic arrangement, I consider myself an amateur musician. **Do you have experience at the university level or as a practicing composer or performer?** If so, I am interested in what you have to say about how I have approached the ideas from these fields. 

A few examples of things I am interested in:
- Jazz theory: Are there general, scale-based ways to determine "available tensions" on any arbitrary chord in jazz theory?
- Classical theory: Are there objective methods to evaluate the effectiveness of a written species counterpoint?
- Are there ways of categorizing the notes in a melody in a general way? (i.e. that do not rely on jazz or classical conventions)
- Do the ways I have modeled or named certain concepts seem strange? Can you suggest better alternatives?

If you are interested in talking about these or any other music theory topics, please reach out to me at `@duncan` on the [Elm Slack](https://elmlang.herokuapp.com/).
